
#falling and respawning
execute as @a[tag=hasBall,limit=1] at @s if score @s y matches ..51 run tag @s add loseBall
execute as @a[scores={y=..51},gamemode=adventure,tag=joined] run tag @s add respawn
execute as @a[scores={y=..51},gamemode=adventure,tag=joined] run tag @s add respawning
execute if entity @a[tag=respawning] run function sette:respawning
scoreboard players reset @a[scores={respawn=60..}] respawn

#effect
effect give @a[tag=hasBall] glowing 1 10 true
execute as @e[type=arrow,limit=1] if entity @s run data merge entity @s {Glowing:1b}
execute as @a at @s run effect clear @s luck
effect clear @a[tag=!hasBall] glowing

#ball player
execute if score ball_item game_stats matches 0 run clear @a[tag=!hasBall] bow
execute if score ball_item game_stats matches 0 if score powerups game_stats matches 0 run replaceitem entity @a[tag=hasBall,nbt=!{Inventory:[{id:"minecraft:bow",Count:1b}]}] hotbar.0 bow
execute if score ball_item game_stats matches 0 if score powerups game_stats matches 1 run replaceitem entity @a[tag=hasBall,nbt=!{Inventory:[{id:"minecraft:bow",Count:1b}]}] weapon.offhand bow
execute if score ball_item game_stats matches 0..1 run clear @a[tag=!hasBall] tipped_arrow{display:{Name:'{"text":"Arrow of Luck","italic":false}'},CustomPotionColor:4704046,HideFlags:63}
execute if score ball_item game_stats matches 0..1 if score powerups game_stats matches 0 run replaceitem entity @a[tag=hasBall,nbt=!{Inventory:[{id:"minecraft:arrow",Count:2b}]}] hotbar.1 tipped_arrow{display:{Name:'{"text":"Arrow of Luck","italic":false}'},CustomPotionColor:4704046,HideFlags:63}
execute if score ball_item game_stats matches 0..1 if score powerups game_stats matches 1 run replaceitem entity @a[tag=hasBall,nbt=!{Inventory:[{id:"minecraft:arrow",Count:2b}]}] hotbar.8 tipped_arrow{display:{Name:'{"text":"Arrow of Luck","italic":false}'},CustomPotionColor:4704046,HideFlags:63}
execute if score ball_item game_stats matches 1 run clear @a[tag=!hasBall] crossbow
execute if score ball_item game_stats matches 1 unless entity @a[tag=hasBall,limit=1,nbt={Inventory:[{id:"minecraft:crossbow",Count:1b}]}] unless entity @a[tag=hasBall,limit=1,nbt={Inventory:[{id:"minecraft:crossbow",Count:2b}]}] if score powerups game_stats matches 0 run replaceitem entity @a[tag=hasBall,nbt=!{Inventory:[{id:"minecraft:crossbow",Count:2b}]}] hotbar.0 crossbow{Enchantments:[{id:quick_charge,lvl:3}]}
execute if score ball_item game_stats matches 1 unless entity @a[tag=hasBall,limit=1,nbt={Inventory:[{id:"minecraft:crossbow",Count:1b}]}] unless entity @a[tag=hasBall,limit=1,nbt={Inventory:[{id:"minecraft:crossbow",Count:2b}]}] if score powerups game_stats matches 1 run replaceitem entity @a[tag=hasBall,nbt=!{Inventory:[{id:"minecraft:crossbow",Count:2b}]}] weapon.offhand crossbow{Enchantments:[{id:quick_charge,lvl:3}]}
execute if score ball_item game_stats matches 2 run clear @a[tag=!hasBall] trident
execute if score ball_item game_stats matches 2 run replaceitem entity @a[tag=hasBall,nbt=!{Inventory:[{id:"minecraft:trident",Count:2b}]}] hotbar.0 trident
execute if score ball_item game_stats matches 3 run replaceitem entity @a[tag=hasBall,nbt=!{Inventory:[{id:"minecraft:snowball",Count:2b}]}] hotbar.0 snowball

kill @e[type=item,nbt={Item:{id:"minecraft:tipped_arrow"}}]
kill @e[type=item,nbt={Item:{id:"minecraft:bow"}}]
kill @e[type=item,nbt={Item:{id:"minecraft:trident"}}]

#lose ball
execute if entity @a[team=red,tag=loseBall] run tag @r[team=blue] add hasBall
execute if entity @a[team=red,tag=loseBall] run tellraw @a ["",{"selector":"@a[tag=loseBall]","color":"red"},{"text":" has lost the ball.","color":"gold"}]
execute if entity @a[team=red,tag=loseBall] run playsound minecraft:entity.firework_rocket.launch master @a ~ ~ ~ 100 1
execute if entity @a[team=red,tag=loseBall] run tag @a[team=red] remove hasBall
tag @a[team=red] remove loseBall

execute if entity @a[team=blue,tag=loseBall] run tag @r[team=red] add hasBall
execute if entity @a[team=blue,tag=loseBall] run tellraw @a ["",{"selector":"@a[tag=loseBall]","color":"blue"},{"text":" has lost the ball.","color":"gold"}]
execute if entity @a[team=blue,tag=loseBall] run playsound minecraft:entity.firework_rocket.launch master @a ~ ~ ~ 100 1
execute if entity @a[team=blue,tag=loseBall] run tag @a[team=blue] remove hasBall
tag @a[team=blue] remove loseBall

#tag arrows
execute as @a[tag=hasBall,team=red] at @s positioned ~ ~1 ~ run tag @e[type=arrow,limit=1,distance=..2,sort=nearest] add hasBall
execute as @a[tag=hasBall,team=red] at @s positioned ~ ~1 ~ run tag @e[type=arrow,limit=1,distance=..2,sort=nearest] add redBall

execute as @a[tag=hasBall,team=blue] at @s positioned ~ ~1 ~ run tag @e[type=arrow,limit=1,distance=..2,sort=nearest] add hasBall
execute as @a[tag=hasBall,team=blue] at @s positioned ~ ~1 ~ run tag @e[type=arrow,limit=1,distance=..2,sort=nearest] add blueBall

execute if entity @e[type=arrow,tag=hasBall] run tag @a remove hasBall
team join red @e[type=arrow,tag=redBall]
team join blue @e[type=arrow,tag=blueBall]
#tag trident
execute as @a[tag=hasBall,team=red] at @s positioned ~ ~1 ~ run tag @e[type=trident,limit=1,distance=..3,sort=nearest] add hasBall
execute as @a[tag=hasBall,team=red] at @s positioned ~ ~1 ~ run tag @e[type=trident,limit=1,distance=..3,sort=nearest] add redBall

execute as @a[tag=hasBall,team=blue] at @s positioned ~ ~1 ~ run tag @e[type=trident,limit=1,distance=..3,sort=nearest] add hasBall
execute as @a[tag=hasBall,team=blue] at @s positioned ~ ~1 ~ run tag @e[type=trident,limit=1,distance=..3,sort=nearest] add blueBall

execute if entity @e[type=trident,tag=hasBall] run tag @a remove hasBall
team join red @e[type=trident,tag=redBall]
team join blue @e[type=trident,tag=blueBall]

#reset player's ability to get shot and score
execute as @a[scores={bow=1..}] at @s if entity @a[tag=hasBall,distance=0.1..] run scoreboard players reset @s bow
execute as @a[scores={crossbow=1..}] at @s if entity @a[tag=hasBall,distance=0.1..] run scoreboard players reset @s crossbow
execute as @a[scores={trident=1..}] at @s if entity @a[tag=hasBall,distance=0.1..] run scoreboard players reset @s trident
execute as @a[scores={snowball=1..}] at @s if entity @a[tag=hasBall,distance=0.1..] run scoreboard players reset @s snowball


#arrow hits ground
execute as @e[type=arrow,tag=hasBall,tag=redBall,limit=1,nbt={inGround:1b}] at @s run tag @r[team=blue] add hasBall
execute as @e[type=arrow,tag=hasBall,tag=redBall,limit=1,nbt={inGround:1b}] at @s run tellraw @a ["",{"selector":"@a[tag=hasBall]"},{"text":" has the ball!","color":"gold"}]
execute as @e[type=arrow,tag=hasBall,tag=redBall,limit=1,nbt={inGround:1b}] at @s run playsound minecraft:entity.firework_rocket.launch master @a ~ ~ ~ 100 1
execute as @e[type=arrow,tag=hasBall,tag=redBall,limit=1,nbt={inGround:1b}] at @s run kill @s

execute as @e[type=arrow,tag=hasBall,tag=blueBall,limit=1,nbt={inGround:1b}] at @s run tag @r[team=red] add hasBall
execute as @e[type=arrow,tag=hasBall,tag=blueBall,limit=1,nbt={inGround:1b}] at @s run tellraw @a ["",{"selector":"@a[tag=hasBall]"},{"text":" has the ball!","color":"gold"}]
execute as @e[type=arrow,tag=hasBall,tag=blueBall,limit=1,nbt={inGround:1b}] at @s run playsound minecraft:entity.firework_rocket.launch master @a ~ ~ ~ 100 1
execute as @e[type=arrow,tag=hasBall,tag=blueBall,limit=1,nbt={inGround:1b}] at @s run kill @s
#trident hits ground
execute as @e[type=trident,tag=hasBall,tag=redBall,limit=1,nbt={inGround:1b}] at @s run tag @r[team=blue] add hasBall
execute as @e[type=trident,tag=hasBall,tag=redBall,limit=1,nbt={inGround:1b}] at @s run tellraw @a ["",{"selector":"@a[tag=hasBall]"},{"text":" has the ball!","color":"gold"}]
execute as @e[type=trident,tag=hasBall,tag=redBall,limit=1,nbt={inGround:1b}] at @s run playsound minecraft:entity.firework_rocket.launch master @a ~ ~ ~ 100 1
execute as @e[type=trident,tag=hasBall,tag=redBall,limit=1,nbt={inGround:1b}] at @s run kill @s

execute as @e[type=trident,tag=hasBall,tag=blueBall,limit=1,nbt={inGround:1b}] at @s run tag @r[team=red] add hasBall
execute as @e[type=trident,tag=hasBall,tag=blueBall,limit=1,nbt={inGround:1b}] at @s run tellraw @a ["",{"selector":"@a[tag=hasBall]"},{"text":" has the ball!","color":"gold"}]
execute as @e[type=trident,tag=hasBall,tag=blueBall,limit=1,nbt={inGround:1b}] at @s run playsound minecraft:entity.firework_rocket.launch master @a ~ ~ ~ 100 1
execute as @e[type=trident,tag=hasBall,tag=blueBall,limit=1,nbt={inGround:1b}] at @s run kill @s

#random thing not sure if i even need to keep this but i'll keep it
kill @e[type=arrow,nbt={inGround:1b}]

#knockback armour
execute if score speed_jumping game_stats matches 1.. run function sette:boots
scoreboard players add @a jump 0
execute if score inverted_knockback game_stats matches 0 if score speed_jumping game_stats matches 0 run replaceitem entity @a[tag=!hasBall] armor.feet minecraft:diamond_boots{HideFlags:3,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],AttributeModifiers:[{AttributeName:"generic.knockbackResistance",Name:"generic.knockbackResistance",Amount:100,Operation:0,UUIDLeast:942845,UUIDMost:494953,Slot:"feet"},{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.1,Operation:1,UUIDLeast:874203,UUIDMost:135679}]} 1
execute if score inverted_knockback game_stats matches 0 run clear @a[tag=hasBall] diamond_boots
#inverted knockbackarmour
execute if score inverted_knockback game_stats matches 1 if score speed_jumping game_stats matches 0 run replaceitem entity @a[tag=hasBall] armor.feet minecraft:diamond_boots{HideFlags:3,Enchantments:[{id:"minecraft:binding_curse",lvl:1s}],AttributeModifiers:[{AttributeName:"generic.knockbackResistance",Name:"generic.knockbackResistance",Amount:100,Operation:0,UUIDLeast:942845,UUIDMost:494953,Slot:"feet"},{AttributeName:"generic.movementSpeed",Name:"generic.movementSpeed",Amount:0.1,Operation:1,UUIDLeast:874203,UUIDMost:135679}]} 1
execute if score inverted_knockback game_stats matches 1 run clear @a[tag=!hasBall] diamond_boots

#game ends
execute if score Red score = goal game_stats run tellraw @a ["",{"text":"Red wins!","color":"red"}]
execute if score Red score = goal game_stats run function sette:end

execute if score Blue score = goal game_stats run tellraw @a ["",{"text":"Blue wins!","color":"blue"}]
execute if score Blue score = goal game_stats run function sette:end

#for scores
execute unless score red score matches 1.. run scoreboard players add Red score 0
execute unless score blue score matches 1.. run scoreboard players add Blue score 0

#detect whether the ball is red or blue
execute as @a[team=red,tag=!red_team] if entity @s run tag @s add red_team
execute as @a[team=blue,tag=!blue_team] if entity @s run tag @s add blue_team

tag @a[tag=!hasBall,team=red] remove red_team
tag @a[tag=!hasBall,team=blue] remove blue_team

#time elapsed
scoreboard players add time_elapsed game_stats 1

#run the terrain functions
execute if score float_terrain game_stats matches 1 if score time_elapsed game_stats = Rand random unless score went_down terrain matches 1 unless score Rand random matches 0..10 run scoreboard players set Supersette terrain -1
execute if score float_terrain game_stats matches 1 if score time_elapsed game_stats = Rand random unless score went_down terrain matches 1 run scoreboard players add Rand random 1200
execute if score float_terrain game_stats matches 1 if score time_elapsed game_stats = Rand random if score went_down terrain matches 1 run scoreboard players set Supersette terrain 1

#speed
execute if score speed game_stats matches 1 run effect give @a speed 1 0 true
execute if score speed game_stats matches 2 run effect give @a speed 1 1 true

#jump boost
execute if score jump_boost game_stats matches 1 run effect give @a jump_boost 1 0 true
execute if score jump_boost game_stats matches 2 run effect give @a jump_boost 1 1 true
execute if score jump_boost game_stats matches 3 run effect give @a jump_boost 1 2 true

#powerups
execute if score powerups game_stats matches 1 run scoreboard players add powerups powerups 1
execute if score powerups powerups matches 25.. run scoreboard players reset powerups powerups
execute if score powerups game_stats matches 1 if score powerups powerups matches 10 run function sette:powerups/main

#bug fix
execute as @a[tag=hasBall] at @s if entity @a[tag=hasBall,distance=0.1..] run function sette:ball/ball_reset

#CLUTCH GAMEMODE
execute if score gamemode game_stats matches 1 run scoreboard players add ticks game_stats 1
execute if score ticks game_stats matches 2.. run scoreboard players set ticks game_stats 0
execute if score gamemode game_stats matches 1 if score ticks game_stats matches 1 as @a[tag=hasBall] run xp add @s 1 levels
execute if score gamemode game_stats matches 1 run scoreboard players add @a[team=!spectator] level 0
execute if score gamemode game_stats matches 1 as @a[scores={level=100..},team=red] run function sette:score/red
execute if score gamemode game_stats matches 1 as @a[scores={level=100..},team=blue] run function sette:score/blue

#ball placer
execute if entity @e[type=minecraft:area_effect_cloud,tag=ball_placer,limit=1] run function sette:ball/place
execute as @e[type=armor_stand,tag=give_ball] at @s if entity @a[distance=..2,team=!spectator] run tag @a[distance=..2,limit=1] add hasBall
execute as @e[type=armor_stand,tag=give_ball] at @s if entity @a[distance=..2,team=!spectator] run function sette:ball/give_ball
execute as @e[type=armor_stand,tag=give_ball] at @s if entity @a[distance=..2,team=!spectator] run kill @s

#TEAMS COLOR DETECTION
execute as @a[team=red] at @s run particle dust 1 0 0 1 ~ ~ ~ 0.15 0.1 0.15 0 1
execute as @a[team=blue] at @s run particle dust 0.25 0.25 1 1 ~ ~ ~ 0.15 0.1 0.15 0 1

#check if ball exists
execute store result score ballExists game_stats if entity @a[tag=hasBall]
execute if score ballExists game_stats matches 0 if score time_elapsed game_stats matches 310.. unless entity @e[tag=give_ball,type=armor_stand,limit=1] run scoreboard players add noBall game_stats 1
execute if score ballExists game_stats matches 0 if score time_elapsed game_stats matches 310.. if score noBall game_stats matches 10 unless entity @e[tag=give_ball,type=armor_stand,limit=1] run function sette:ball/check
execute if entity @e[tag=hasBall] run scoreboard players set noBall game_stats 0